<template>
  <div id="app" 
    v-bind:class="{'is-inactive':this.isInActice}">    
    <svg class="graph" viewBox="0 0 800 1800">
      <g class="grid x-grid">
        <line 
          v-bind:x1="this.xStart" 
          v-bind:x2="this.xStart" 
          v-bind:y1="this.yStart"  
          v-bind:y2="this.yEnd + 1"></line>
      </g>
      <g class="grid y-grid">
        <line 
          v-bind:x1="this.xStart" 
          v-bind:x2="this.xEnd" 
          v-bind:y1="this.yEnd" 
          v-bind:y2="this.yEnd"></line>
      </g>
      <g class="labels x-labels">
          <text class='xlabel' v-bind:key="graphicItem.id" v-for="graphicItem in graphicItems"
            v-bind:x="calcXPos(graphicItem)" y="420">
              {{graphicItem.date.getDate()}}.{{graphicItem.date.getMonth()+1}}.{{graphicItem.date.getFullYear()}}
            </text>
        <text x="400" y="480" class="label-title">{{title}}</text>
      </g>
      <g class="labels y-labels">
        <text v-bind:key="yValue" v-for="yValue in yValues"
          v-bind:x="xStart-10" 
          v-bind:y="calcYPos(yValue)">
          {{calcYValue(yValue)}}
        </text>
        <text x="50" y="200" class="label-title">Price €</text>
      </g>
      <g class="data">        
        <circle v-bind:key="graphicItem.id" v-for="graphicItem in graphicItems"
          v-bind:cx="calcXPos(graphicItem)"
          v-bind:cy="calcYPos(0.5)"
          v-bind:data-value="graphicItem.price" r="4">
            <animate id="animation" 
              attributeName="cy"
              v-bind:from="calcYPos(0.5)"
              v-bind:to="calcYPosWithoutOffset(calcYPercent(graphicItem.price))"
              v-bind:begin="calcBegin(graphicItem.id)"
              v-bind:dur="animationTime + 's'"
              fill="freeze"></animate>
            {{graphicItem.price}}
          </circle>
      </g>
    </svg>
  </div>
</template>

<script>
  export default {
    name: 'Graphics',
    props: ["items", "title"],
    data() {
      return {
        graphicItems: this.items,
        isInActice: true,
        xStart: 120,
        xEnd: 705,
        yStart: 5,
        yEnd: 370,
        yMin: 0,
        yMax: 0,
        yValues: [0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0],
        animationTime: 1,
      }
    },
    created() {
      if(this.graphicItems && this.graphicItems.length)
      {
        this.isInActice = false;

        var tempMax = -999999;
        var tempMin = 9999999;

        this.graphicItems.forEach(item => {
          if(item.price > tempMax)
            tempMax = item.price;
          if(item.price < tempMin)
            tempMin = item.price;
        });

        this.yMax = tempMax;
        this.yMin = tempMin;

        console.log("From graphics");
        console.log(this.yMin);
        console.log(this.yMax);
        console.log(this.graphicItems);
      }
    },
    methods: {
      calcXPos(graphicItem) {
        var itemNumber = this.graphicItems.length - 1;
        var range = this.xEnd - this.xStart;
        return this.xStart + graphicItem.id * range / itemNumber;
      },
      calcYPercent(price) {
        var range = this.yMax - this.yMin;
        if(range == 0)
          return 0;
        var percent = price / range;
        return percent;
      },
      calcYPos(percent) {
        var range = this.yEnd - this.yStart;
        return this.yEnd - percent * range + 5;
      },
      calcYPosWithoutOffset(percent) {
        var range = this.yEnd - this.yStart;
        return this.yEnd - percent * range;
      },
      calcYValue(percent) {
        if(percent == 0)
          return 0;
        return ((this.yMax - this.yMin) * percent).toFixed(2);
      },
      calcBegin(index)
      {
        return (index * this.animationTime * 0.1) + "s";
        // return "0s";
      },
    }
  }; // https://advitum.de/blog/2015/09/das-linien-diagramm-interaktive-svg-diagramme-im-web/


  // Points = {
  // xLabel = "X Achsen Beschriftung",
  // xValues = [x1, x2, x3, ...],
  // yLabel = "Y Achsen Beschriftung",
  // yValues = [y1, y2, y3, ...]
  //}
</script>

<style>

  .is-inactive{
    display: none;
  }

  .graph .labels.x-labels {
    text-anchor: middle;
  }

  .graph .labels.y-labels {
    text-anchor: end;
  }

  .graph .grid {
    stroke: #ccc;
    stroke-dasharray: 0;
    stroke-width: 1;
  }

  .labels {
    font-size: 13px;
  }

  .label-title {
    font-weight: bold;
    text-transform: uppercase;
    font-size: 12px;
    fill: black;
  }

  .data {
    fill: red;
    stroke-width: 1; 
  }

  .xlabel {
    writing-mode: tb;
  }

</style>
